from ox_script import *
import re
import os
import datetime
import openpyxl

form_list = []
selected_form = ""
value1=""
serial_num_controller = None
current_workbook = None
current_worksheet = None
current_filepath = None
current_worksheet_line = 2
serial = None

def find_forms():
    global selected_form
    global form_list
    form_list = [file for file in os.listdir() if file.endswith(".txt")]
    if len(form_list) != 0:
        selected_form = form_list[0]


def update_selected_form(value):
    global form_list
    global selected_form
    selected_form = form_list[int(value)]
    create_excel(selected_form + datetime.datetime.now())








# If the script is being run as the main program
if __name__ == "__main__":
    find_forms()
    PTK_UIInit(
        PTK_UIPage(
            form_list_controller := PTK_UIList(
                title="Form Name",
                items=form_list,
                valueType="int",
                value=0,
                Onpressed=update_selected_form,
            ),
            barcode_controller := PTK_UIInput(
                title="条码", enabled=False, value="", Onsubmit=lambda x: None
            ),
        ),
        require_execute_confirmation=False
    )
  #  create_excel(selected_form + str(datetime.datetime.now()) + ".xlsx")
    while True:
        scanned = PTK_GetPortData(PORT_USBHOST, timeout=500)
        if scanned != -1:
            barcode_controller.update(scanned)
            # 打开Excel文件
            excel_file_path = 'record1.xlsx'
            workbook = openpyxl.load_workbook(excel_file_path)

            # 获取工作表
            sheet = workbook.active  # 或者使用 workbook['SheetName'] 获取特定名称的工作表
            #print(sheet)

            # 查询第二列的值，并输出第一列的值
            desired_value = scanned  # 替换为你想要查询的第二列的值
            #print(desired_value)
            #print(sheet.iter_rows(values_only=True))

            output_values = []

            for row in sheet.iter_rows(values_only=True):
                if str(row[1]).strip()[4:7] == str(desired_value).strip()[4:7]:  # 第二列的索引是1（从0开始）
                    output_values.append(row[0])  # 第一列的索引是0（从0开始）
                    output_values.append(row[2])  # 第一列的索引是0（从0开始）
                    output_values.append(row[3])  # 第一列的索引是0（从0开始）
                    output_values.append(row[4])  # 第一列的索引是0（从0开始）
                    # 打印查询结果
            


            # 关闭Excel文件
            workbook.close()
            if output_values:
                value1 = output_values[0]
                value2 = output_values[1]
                value3 = output_values[2]
                value4 = output_values[3]
                cmd = PTK_UpdateAllFormVariables(
                    selected_form,
                    Input1=scanned,Input2=value1,Input3=value2,Input4=value3,Input5=value4,
                )
                PTK_SendCmdToPrinter(cmd)
            else:
                barcode_controller.update("没有查询到记录，请重新扫描")

            

                

